function v=k(x,m,s,typ);
% implementace jadrovych funkci
%
% vstupni parametry:
% x - 1. vstupni vektor
% m - 2. vstupni vektor
% s - parametr pro polynomialni funkci - rad polynomu nebo pro RBF parametr sigma
%     (vyber podle parametru typ)
% typ - vyber jadrove funkce:
%                 'lin' - linearni funkce
%                 'poly' - polynomialni funkce
%                 'rbf' - RBF funkce 
switch lower(typ)
   
   case 'lin'
		%linern
      v=x'*m;
   case 'poly'   
      % polynomialni
      v=(x'*m+1)^s;
   case 'rbf'  
      % RBF funkce
      v=exp(-((x-m)'*(x-m))*s);
   otherwise
      % pro ostatni linearni
      v=x'*m;
   end